"""Class with all callback used in program
"""

import gtk
import RunApplication
from os.path import isfile

class Callbacks:
    """Class with all callback used in program
    @author: Bartosz 'Perfekcik' Alchimowicz
    """

    def __init__(self, pluginDB):
	self.__treeView = None
	self.__pluginDB = pluginDB
	self.__PLUGIN_NAME = 0
	self.__PLUGIN_NUMBER = 1

    def destroy(self, widget = None, data = None):
	gtk.main_quit()
	
    def delete_event(self, widget, event = None, data = None):
	return gtk.FALSE

    def about(self, widget, textView):
	"""Show information about project in treeView window
	"""   
	textView.setText(_('About'), _('This program is under GNU licence, see COPYING file.\n\nAuthor: Bartosz \'Perfekcik\' Alchimowicz\nVersion: 0.1\nContact: perf@poczta.onet.pl'))

    def run(self, widget, data):
	"""Start selected application"""
	treeSelection = data.get_selection()
	model, iter = treeSelection.get_selected()

	if iter:
	    number = model.get_value(iter, self.__PLUGIN_NUMBER)
	    fileName = self.__pluginDB[number].getExe()
	    
	    RunApplication.RunApplication(fileName)
	
	return

    def rowClick(self, selection, data):    
	"""React on cell selection
	"""
	model, iter = selection.get_selected()
	number = model.get_value(iter, self.__PLUGIN_NUMBER)
	plugin = self.__pluginDB[number]
	
	commentPointer = plugin.getComment()
	
    	if isfile(commentPointer):
    	    comment = open(commentPointer).read()

    	else:
            comment = commentPointer

	data.setText(plugin.getName(), comment)
	
	return
		
    def rowDBClick(self, treeView, row, column):
	"""React on dbclick
	"""
	listStore = treeView.get_model()
	iter = listStore.get_iter(row)
	number = listStore.get_value(iter, self.__PLUGIN_NUMBER)
	
	fileName = self.__pluginDB[number].getExe()
	RunApplication.RunApplication(fileName)
	
	return
