"""Class for holding information about specified plugin.
"""

class Plugin:
    """Class for holding information about specified plugin.
    There are no setters, once created object is invariable.
    @author: Bartosz 'Perfekcik' Alchimowicz
    """

    def __init__(self, name, exe, comment):
	"""@type name: str
	@param name: plugin name
	@type exe: str
	@param exe: path to plugin
	@type comment: str
	@param comment: path to description
	"""
	self.name = name
	self.exe = exe
	self.comment = comment

    def getName(self):
	"""@rtype: str
	@return: plugin name listed in acc.cfg file
	"""
	return self.name

    def getExe(self):
	"""@rtype: str
	@return: path to plugin
	"""
	return self.exe
	
    def getComment(self):
	"""@rtype: str
	@return: path to file with description
	"""
	return self.comment
