#!/usr/bin/env python
# -*- coding: UTF-8 -*-
# Author: Bartosz 'Perfekcik' Alchimowicz
# Date: Thu Nov 18 00:10:54 2004
#
# TODO: input file may be diffretn encoded (actual only utf-8 is supported)
#

import re
import codecs
import sys
from os import access
from os import R_OK
from os import mkdir
from os.path import abspath
from os.path import basename
from os.path import isdir


def convertFile(fileNameIn, fileNameOut):
    #
    # Open files
    #
    fileIn = codecs.open(fileNameIn, 'r', 'utf-8').read().split('\n')
    fileOut = codecs.open(fileNameOut, 'w', 'utf-8')
 
    # 
    # Set regex
    #
    name = re.compile("Name(\[\w{2}(_\w{2})?\])?=\w*");
    comment = re.compile("Comment(\[\w{2}(_\w{2})?\])?=\w*");
    exe = re.compile("Exec=\w*");

    #
    # Parse file
    #
    for line in fileIn:
        if name.match(line):
	    fileOut.write(line+'\n')
            continue
    
        if comment.match(line):
            fileOut.write(line+'\n')
            continue

        if exe.match(line):
	    line = line.split(' ');
            fileOut.write(line[0]+'\n')
            continue

def convertName(fileNameIn):
    fileNameIn = fileNameIn.split('.')
    fileNameOut = ""
    
    for i in range(0, len(fileNameIn)-1):
        fileNameOut = fileNameOut + fileNameIn[i]
	 
    return fileNameOut

#########
#
# START
#
####

if len(sys.argv) != 3:
    print 'ERROR!'
    print 'Run:'
    print 'dtc.py input.desktop output_directory'
    sys.exit(1)


fileNameIn = sys.argv[1]
dirNameOut = abspath(sys.argv[2])


if not access(fileNameIn, R_OK):
    print 'ERROR! No input file'
    sys.exit(2)

if not isdir(dirNameOut):
    print 'ERROR! second param should be a directory'
    sys.exit(3)


dirNameOut = dirNameOut + '/' + convertName(basename(fileNameIn))

if not isdir(dirNameOut):
    mkdir(dirNameOut)

print 'Creating acc.cfg in ' + dirNameOut
convertFile(fileNameIn, dirNameOut + '/acc.cfg') 
